package cn.iocoder.yudao.module.basic.api.businessinfo;


import cn.hutool.core.bean.BeanUtil;
import cn.iocoder.yudao.framework.common.pojo.CommonResult;
import cn.iocoder.yudao.module.basic.api.redis.dto.BusinessInfoDTO;
import cn.iocoder.yudao.module.basic.dal.dataobject.businessinfo.BusinessInfoDO;
import cn.iocoder.yudao.module.basic.service.businessinfo.BusinessInfoService;
import org.apache.dubbo.config.annotation.DubboService;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;

import static cn.iocoder.yudao.module.system.enums.ApiConstants.VERSION;

@RestController // 提供 RESTful API 接口，给 Feign 调用
@DubboService(version = VERSION) // 提供 Dubbo RPC 接口，给 Dubbo Consumer 调用
@Validated
public class BusinessInfoApiImpl implements BusinessInfoApi {

    @Resource
    private BusinessInfoService businessInfoService;

    @Override
    public CommonResult<BusinessInfoDTO> getBusinessInfoById(Long id) {
        BusinessInfoDO businessInfoDO = businessInfoService.getBusinessInfo(id);
        BusinessInfoDTO businessInfoDTO = new BusinessInfoDTO();
        BeanUtil.copyProperties(businessInfoDO, businessInfoDTO);
        return CommonResult.success(businessInfoDTO);
    }

    @Override
    public CommonResult<BusinessInfoDTO> getBusinessInfoByBusinessId(String businessId) {
        BusinessInfoDO businessInfoByBusinessId = businessInfoService.getBusinessInfoByBusinessId(businessId);
        BusinessInfoDTO businessInfoDTO = new BusinessInfoDTO();
        BeanUtil.copyProperties(businessInfoByBusinessId, businessInfoDTO);
        return CommonResult.success(businessInfoDTO);
    }

    @Override
    public CommonResult<BusinessInfoDTO> getBusinessInfoByIdWithOutTenantId(Long id) {
        BusinessInfoDO businessInfoDO = businessInfoService.getBusinessInfo(id);
        BusinessInfoDTO businessInfoDTO = new BusinessInfoDTO();
        BeanUtil.copyProperties(businessInfoDO, businessInfoDTO);
        return CommonResult.success(businessInfoDTO);
    }
}
